%% Space Time Unified Framework for Large MIMO
%% Add multi prod toolbox
%addpath('Multiprod');  

%% Parameter loading
%load_para_massiveMIMO_WINNER;
%% Initial time trace
TimeTrace=cell(1,para.T_length);
TimeTrace{1}.para=para;
DumpPhase=cell(1,para.T_length);

%% Rotation matrix calculation
RotMatrix_rx_x=[1 0 0;0 cos(para.Rx_Rot_x) -sin(para.Rx_Rot_x); 0 sin(para.Rx_Rot_x) cos(para.Rx_Rot_x)];
RotMatrix_rx_y=[cos(para.Rx_Rot_y) 0 sin(para.Rx_Rot_y); 0 1 0;-sin(para.Rx_Rot_y) 0 cos(para.Rx_Rot_y)];
RotMatrix_rx_z=[cos(para.Rx_Rot_z) -sin(para.Rx_Rot_z) 0;sin(para.Rx_Rot_z) cos(para.Rx_Rot_z) 0; 0 0 1];
RotMatrix_rx=RotMatrix_rx_z*RotMatrix_rx_y*RotMatrix_rx_x;
RotMatrix_tx_x=[1 0 0;0 cos(para.Tx_Rot_x) -sin(para.Tx_Rot_x); 0 sin(para.Tx_Rot_x) cos(para.Tx_Rot_x)];
RotMatrix_tx_y=[cos(para.Tx_Rot_y) 0 sin(para.Tx_Rot_y); 0 1 0;-sin(para.Tx_Rot_y) 0 cos(para.Tx_Rot_y)];
RotMatrix_tx_z=[cos(para.Tx_Rot_z) -sin(para.Tx_Rot_z) 0;sin(para.Tx_Rot_z) cos(para.Tx_Rot_z) 0; 0 0 1];
RotMatrix_tx=RotMatrix_tx_z*RotMatrix_tx_y*RotMatrix_tx_x;
%% Birth Death Process for clusters (init)
% Cluster map for Rx
Nc0=(para.lambdaG/para.lambdaR);             % initial number of clusters

TimeTrace{1}.Cmatrix_rx=zeros(para.M_R,Nc0);       % cluster matrix for Rx
TimeTrace{1}.Cmatrix_tx=zeros(para.M_T,Nc0);       % cluster matrix for Tx
if para.Polarization_Rx
    PR_rx=exp(-para.lambdaR*para.delta_rx/2*para.lambda/para.A_Corr_distance);            % reconbination probability
else
    PR_rx=exp(-para.lambdaR*para.delta_rx*para.lambda/para.A_Corr_distance);            % reconbination probability    
end
if para.Polarization_Tx
    PR_tx=exp(-para.lambdaR*para.delta_tx/2*para.lambda/para.A_Corr_distance);            % reconbination probabilityMax_Cluster_Index_Rx=ones(1,para.M_R)*Nc0;                   % max cluster index init
else
    PR_tx=exp(-para.lambdaR*para.delta_tx*para.lambda/para.A_Corr_distance);            % reconbination probabilityMax_Cluster_Index_Rx=ones(1,para.M_R)*Nc0;                   % max cluster index init
    
end

for k1=1:Nc0
    % generate intial attachment at the Rx
    l_rx=randi(para.M_R);
    TimeTrace{1}.Cmatrix_rx(l_rx,k1)=1;
    k2=l_rx-1;
    while (k2>=1&&rand(1)<PR_rx)
        TimeTrace{1}.Cmatrix_rx(k2,k1)=1;
        k2=k2-1;
    end
    k2=l_rx+1;
    while (k2<=para.M_R&&rand(1)<PR_rx)
        TimeTrace{1}.Cmatrix_rx(k2,k1)=1;
        k2=k2+1;
    end
    % generate intial attachment at the Tx
    l_tx=randi(para.M_T);
    TimeTrace{1}.Cmatrix_tx(l_tx,k1)=1;
    k2=l_tx-1;
    while (k2>=1&&rand(1)<PR_tx)
        TimeTrace{1}.Cmatrix_tx(k2,k1)=1;
        k2=k2-1;
    end
    k2=l_tx+1;
    while (k2<=para.M_T&&rand(1)<PR_tx)
        TimeTrace{1}.Cmatrix_tx(k2,k1)=1;
        k2=k2+1;
    end
end
if para.Polarization_Rx
    
    TimeTrace{1}.Cmatrix_rx(2:2:end,:)=TimeTrace{1}.Cmatrix_rx(1:2:end,:);
end

if para.Polarization_Tx
    
    TimeTrace{1}.Cmatrix_tx(2:2:end,:)=TimeTrace{1}.Cmatrix_tx(1:2:end,:);
end

  

%% Joint cluster map for Rx and Tx
% [1C_number_Tx  2Delay 3Power 4AAoA 5AAoD 6EAoA 7EAoD 8D_n_R 9D_n_T 10meanAAoA 11meanAAoD 12meanEAoA 13meanEAoD 14ClusterTvE 15ClusterTvA 16ClusterRvE 17ClusterRvA 18meanDelay]
% random shuffling and pairing
TimeTrace{1}.Cluster_Map=[(1:Nc0)'];
% generate cluster delays
Delay=-para.DS_r*para.ds_sigma*log(rand(Nc0,1));
TimeTrace{1}.Cluster_Map=[TimeTrace{1}.Cluster_Map Delay];
% generate cluster power
P=exp(-TimeTrace{1}.Cluster_Map(:,2)*(para.DS_r-1)/para.DS_r/para.ds_sigma).*10.^(-para.Per_cluster_shadowing*randn(Nc0,1)/10);
TimeTrace{1}.Cluster_Map=[TimeTrace{1}.Cluster_Map P];
%generate AoA and AoD
AAoA=(para.AAoA_variance*randn(Nc0,1))/180*pi+para.nu_A_R;      % Azimuth angle Rx
AAoD=(para.AAoD_variance*randn(Nc0,1))/180*pi+para.nu_A_T;      % Azimuth angle Tx
EAoA=(para.EAoA_variance*randn(Nc0,1))/180*pi+para.nu_E_R;      % Elevation angle Rx
EAoD=(para.EAoD_variance*randn(Nc0,1))/180*pi+para.nu_E_T;      % Elevation angle Rx

% EAoA=(para.EAoA_variance*zeros(Nc0,1))/180*pi+para.nu_E_R;      % Elevation angle Rx
% EAoD=(para.EAoD_variance*zeros(Nc0,1))/180*pi+para.nu_E_T;      % Elevation angle Rx

%generate cluster distance
D_n_R=exprnd(para.d_Rx_mean,Nc0,1)+para.d_Rx_min;
D_n_T=exprnd(para.d_Tx_mean,Nc0,1)+para.d_Tx_min;
%generate tau tilder
tau_tilder=exprnd(para.tau_tilder_mean,Nc0,1)+para.tau_tilder_min;

TimeTrace{1}.Cluster_Map=[TimeTrace{1}.Cluster_Map AAoA AAoD EAoA EAoD D_n_R D_n_T AAoA AAoD EAoA EAoD...
    pi*(rand(Nc0,1)-0.5) 2*pi*(rand(Nc0,1)-0.5) pi*(rand(Nc0,1)-0.5) 2*pi*(rand(Nc0,1)-0.5)...
    TimeTrace{1}.Cluster_Map(:,2)];


%% Sub path

Subpath_numbers=max(poissrnd(para.mean_num_subpath,size(TimeTrace{1}.Cluster_Map,1),1),1);
tmp_Cluster_Map=TimeTrace{1}.Cluster_Map;
TimeTrace{1}.Cluster_Map=[];
for k1=1:size(tmp_Cluster_Map,1)
    subpath_angular_offset=pi/180*MEA_Laplace_offset_cal(Subpath_numbers(k1),para.angular_variance_subpath).';
    subpath_delay_offset=exprnd(para.mean_delay_subpath,Subpath_numbers(k1),1);
    subpath_delay_offset=subpath_delay_offset-min(subpath_delay_offset);
    % generate subpath power
    subpath_power=exp(-subpath_delay_offset*(para.DS_r-1)/para.mean_delay_subpath).*10.^(-para.Per_cluster_shadowing*randn(size(subpath_delay_offset,1),1)/10);
    subpath_power=tmp_Cluster_Map(k1,3)*subpath_power./sum(subpath_power);
    tmp_subpath_properties=kron(ones(Subpath_numbers(k1),1),tmp_Cluster_Map(k1,:));
    tmp_subpath_properties(:,2)=tmp_subpath_properties(:,2)+subpath_delay_offset;
    tmp_subpath_properties(:,3)=subpath_power;
    tmp_subpath_properties(:,4:7)=tmp_subpath_properties(:,4:7)+kron(ones(1,4),subpath_angular_offset);
    TimeTrace{1}.Cluster_Map=[TimeTrace{1}.Cluster_Map;tmp_subpath_properties];
end
clear Subpath_numbers tmp_Cluster_Map tmp_subpath_properties  subpath_angular_offset subpath_delay_offset subpath_power;

DumpPhase{1}.phase_table=zeros(size(TimeTrace{1}.Cluster_Map,1),5);
DumpPhase{1}.phase_table(:,1)=TimeTrace{1}.Cluster_Map(:,1);
DumpPhase{1}.phase_table(:,2:5)=exp(1i*rand(size(TimeTrace{1}.Cluster_Map,1),4));

%% Channel coefficients
FieldPatternRx=TimeTrace{1}.para.FieldPatternRx;
FieldPatternTx=TimeTrace{1}.para.FieldPatternTx;


vR=para.v_R*[cos(para.xi_v_R)*cos(para.theta_v_R);cos(para.xi_v_R)*sin(para.theta_v_R);sin(para.xi_v_R)];
vT=para.v_T*[cos(para.xi_v_T)*cos(para.theta_v_T);cos(para.xi_v_T)*sin(para.theta_v_T);sin(para.xi_v_T)];

Rx_field_pattern=[1;1];

for k2=1:para.T_length

    if k2>1
       [TimeTrace{k2}.Cluster_Map,TimeTrace{k2}.Cmatrix_rx,TimeTrace{k2}.Cmatrix_tx,DumpPhase{k2}.phase_table]=ArrayTimeEvolution(TimeTrace{k2-1}.Cluster_Map,TimeTrace{k2-1}.Cmatrix_rx,TimeTrace{k2-1}.Cmatrix_tx,para,DumpPhase{k2-1}.phase_table);
    end
    Max_tap=size(TimeTrace{k2}.Cluster_Map,1);
    TimeTrace{k2}.h=zeros(para.M_R,para.M_T,Max_tap);
    % Normalized power
    Normalized_power=TimeTrace{k2}.Cluster_Map(:,3)./sum(TimeTrace{k2}.Cluster_Map(:,3));
    for k1=1:Max_tap
        
        % Calculate Dn
        meanAAoA=TimeTrace{k2}.Cluster_Map(k1,10);
        meanAAoD=TimeTrace{k2}.Cluster_Map(k1,11);
        meanEAoA=TimeTrace{k2}.Cluster_Map(k1,12);
        meanEAoD=TimeTrace{k2}.Cluster_Map(k1,13);
        DR_n=TimeTrace{k2}.Cluster_Map(k1,8)*[cos(meanEAoA)*cos(meanAAoA);cos(meanEAoA)*sin(meanAAoA);sin(meanEAoA) ]+[para.D;0;0];
        DT_n=TimeTrace{k2}.Cluster_Map(k1,9)*[cos(meanEAoD)*cos(meanAAoD);cos(meanEAoD)*sin(meanAAoD);sin(meanEAoD)];
        
        % Calculate Dn_k1
        AAoA=TimeTrace{k2}.Cluster_Map(k1,4);
        AAoD=TimeTrace{k2}.Cluster_Map(k1,5);
        EAoA=TimeTrace{k2}.Cluster_Map(k1,6);
        EAoD=TimeTrace{k2}.Cluster_Map(k1,7);
        
        DR_n_k1=TimeTrace{k2}.Cluster_Map(k1,8)*[cos(EAoA)*cos(AAoA);cos(EAoA)*sin(AAoA);sin(EAoA) ]+[para.D;0;0];
        DT_n_k1=TimeTrace{k2}.Cluster_Map(k1,9)*[cos(EAoD)*cos(AAoD);cos(EAoD)*sin(AAoD);sin(EAoD)];
        
        % Calculate vc
        ClusterTvE=TimeTrace{k2}.Cluster_Map(k1,14);
        ClusterTvA=TimeTrace{k2}.Cluster_Map(k1,15);
        ClusterRvE=TimeTrace{k2}.Cluster_Map(k1,16);
        ClusterRvA=TimeTrace{k2}.Cluster_Map(k1,17);
        vcR=para.v_c*[cos(ClusterRvE)*cos(ClusterRvA);cos(ClusterRvE)*sin(ClusterRvA);sin(ClusterRvE)];
        vcT=para.v_c*[cos(ClusterTvE)*cos(ClusterTvA);cos(ClusterTvE)*sin(ClusterTvA);sin(ClusterTvE)];
                
        % Random phase matrix for polarization
        xphase=reshape(DumpPhase{k2}.phase_table(k1,2:5),2,2);
        phase_matrix=[1 sqrt(para.Polar_kappa_linear);sqrt(para.Polar_kappa_linear) 1].*xphase;
        
        if para.Polarization_Tx==0&&para.Polarization_Rx==0
            phase_matrix(1,2)=0;
            phase_matrix(2,1)=0;
        end
        
        
        % Subpath power
        P_n_k1=Normalized_power(k1);
                     
        for m_r=1:para.M_R
            if (TimeTrace{k2}.Cmatrix_rx(m_r,TimeTrace{k2}.Cluster_Map(k1,1))>0.5)
                % Antenna vector Rx
                % If polarization, dimension of the array is halved
                pm_r=ceil(m_r/(2.^para.Polarization_Rx));
                AR_m_r=(para.M_R-2*pm_r+1)/2*para.delta_rx*para.lambda*[cos(para.nu_A_R)*cos(para.nu_E_R);cos(para.nu_A_R)*sin(para.nu_E_R);sin(para.nu_E_R)]+[para.D;0;0];
                DR_m_r_n_k1=DR_n_k1-AR_m_r;
                FieldPattern_Rx = FieldPatternRx(AR_m_r, DR_n_k1,m_r,TimeTrace{1}.para.Polarization_Rx,RotMatrix_rx);
                % Doppler frequency Rx
                fR_m_r_n_k1=1/para.lambda*DR_m_r_n_k1.'*(vR-vcR)/norm(DR_m_r_n_k1);
                for m_t=1:para.M_T
                    if (TimeTrace{k2}.Cmatrix_tx(m_t,TimeTrace{k2}.Cluster_Map(k1,1))>0.5) % visible clusters
                        % Antenna vector Tx
                        % If polarization, dimension of the array is halved
                        pm_t=ceil(m_t/(2.^para.Polarization_Tx));
                        
                        AT_m_t=(para.M_T-2*pm_t+1)/2*para.delta_tx*para.lambda*[cos(para.nu_A_T)*cos(para.nu_E_T);cos(para.nu_A_T)*sin(para.nu_E_T);sin(para.nu_E_T)];
                        DT_m_t_n_k1=DT_n_k1-AT_m_t;
                        FieldPattern_Tx = FieldPatternTx(AT_m_t, DT_n_k1,m_t,TimeTrace{1}.para.Polarization_Tx,RotMatrix_tx);
                        % Polarization phase
                        phaseX=FieldPattern_Tx.'*phase_matrix*FieldPattern_Rx;
                        % Doppler frequency Tx
                        fT_m_t_n_k1=1/para.lambda*DT_m_t_n_k1.'*(vT-vcT)/norm(DT_m_t_n_k1);
                        phase_m_r_m_t_n_k1=2*pi/para.lambda*(norm(DR_m_r_n_k1)+norm(DT_m_t_n_k1));
                        tau_n=(norm(DR_n)+(DT_n))/para.c+TimeTrace{k2}.Cluster_Map(k1,18);
                        TimeTrace{k2}.h(m_r,m_t,k1)=sqrt(P_n_k1)*phaseX*exp(1i*2*pi*(fT_m_t_n_k1+fR_m_r_n_k1)*para.TimeLine(k2)+1i*phase_m_r_m_t_n_k1);
                        
                    end
                    
                end
            end
        end
    end
    
    k2
       
end
% Save results
 if para.SaveResults
    if para.Save_H_only
        if para.is_layer_compressed
            precoding_matrix=zeros(para.M_T,para.nLayer);
            for k1=1:para.nLayer
                precoding_matrix((para.M_T/para.nLayer*(k1-1)+1):(para.M_T/para.nLayer*k1),k1)=1;
            end
            precoding_matrix=1/sqrt(sum(diag(precoding_matrix'*precoding_matrix)))*precoding_matrix;
            for k1=1:length(TimeTrace)
                TimeTrace{k1}=rmfield(TimeTrace{k1},{'Cmatrix_rx','Cmatrix_tx'});
                TimeTrace{k1}.delay=TimeTrace{k1}.Cluster_Map(:,2);
                TimeTrace{k1}=rmfield(TimeTrace{k1},'Cluster_Map');
                TimeTrace{k1}.h=multiprod(TimeTrace{k1}.h,precoding_matrix);
            end
            
            save(strcat(para.ResultName,'_H_only_layer_compressed.mat'), 'TimeTrace','-v7.3');
        else
            for k1=1:length(TimeTrace)
                TimeTrace{k1}=rmfield(TimeTrace{k1},{'Cmatrix_rx','Cmatrix_tx'});
                TimeTrace{k1}.delay=TimeTrace{k1}.Cluster_Map(:,2);
                TimeTrace{k1}=rmfield(TimeTrace{k1},'Cluster_Map');
                TimeTrace{k1}.h=TimeTrace{k1}.h;
            end
            save(strcat(para.ResultName,'_H_only_no_layer_compressed.mat'), 'TimeTrace','-v7.3');

        end

    else
        save(strcat(para.ResultName,'.mat'), 'TimeTrace','-v7.3');
    end
end










